package com.s5gi.item.behaviors;

import com.s5gi.Lacess;
import com.s5gi.effect.LacessEffects;
import com.s5gi.entity.LacessEntities;
import com.s5gi.networking.LacessNetworking;
import com.s5gi.networking.payloads.S2C.HudRendererTimeUpdatePayload;
import com.s5gi.sound.LacessSounds;
import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.minecraft.entity.effect.StatusEffectInstance;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.Item;
import net.minecraft.item.ItemGroup;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.registry.RegistryKey;
import net.minecraft.registry.RegistryKeys;
import net.minecraft.sound.SoundCategory;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Hand;
import net.minecraft.util.Identifier;
import net.minecraft.world.World;

import java.util.Random;

import static com.s5gi.Lacess.MOD_ID;

public class Test_Dust extends Item {
    public Test_Dust(Settings settings) {
        super(settings);
    }

    private Random random = new Random();

    @Override
    public ActionResult use(World world, PlayerEntity user, Hand hand) {
        if (world.isClient) {
            return ActionResult.PASS;
        }


        if (!user.isInCreativeMode()) user.getStackInHand(hand).decrement(1);

        LacessNetworking.S2C.sendPayload(user.getServer().getPlayerManager().getPlayer(user.getUuid()), new HudRendererTimeUpdatePayload("1", System.currentTimeMillis()));
        world.getServer().getWorld(world.getRegistryKey()).spawnParticles(LacessEntities.TEST_PARTICLE, user.getX() , user.getY() , user.getZ(), 25, 1, 1, 1, 0.15);
        world.getServer().getWorld(world.getRegistryKey()).playSound(user, user.getX(), user.getY()+1, user.getZ(), LacessSounds.TEST_SOUND, SoundCategory.PLAYERS, 1, random.nextFloat(0, 1));
        user.addStatusEffect(new StatusEffectInstance(Registries.STATUS_EFFECT.getEntry(LacessEffects.TEST_EFFECT), 40, 1, true, false));


        return ActionResult.SUCCESS;
    }

    public static Item register(String name, RegistryKey<ItemGroup> itemGroup) {
        Identifier id = Identifier.of(MOD_ID, name);
        RegistryKey<Item> key = RegistryKey.of(RegistryKeys.ITEM, id);
        Item.Settings settings = new Item.Settings().registryKey(key);
        Item item = Registry.register(Registries.ITEM, key, new Test_Dust(settings));
        ItemGroupEvents.modifyEntriesEvent(itemGroup)
                .register((itemGroupa) -> itemGroupa.add(item));
        return item;
    }
}
